#!/bin/bash

set -euo pipefail

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"

echo "Building and testing test_libs..."

# Build test_libs
docker run --rm \
  -v "${SCRIPT_DIR}/tests:/tests" \
  -v "${SCRIPT_DIR}/output:/output" \
  -w /tests/test_libs \
  gitea.jde.nz/public/dropshell-build-base:latest \
  sh -c "mkdir -p build && cd build && cmake -DCMAKE_BUILD_TYPE=Release .. && make && cp test_libs /output/"

# Run test_libs
if [ -f "${SCRIPT_DIR}/output/test_libs" ]; then
    echo "Running test_libs..."
    "${SCRIPT_DIR}/output/test_libs"
    echo "test_libs completed successfully!"
else
    echo "test_libs binary not found"
    exit 1
fi

echo ""
echo "Testing ipdemo..."

# Check if ipdemo exists
if [ -f "${SCRIPT_DIR}/output/ipdemo" ]; then
    echo "Running ipdemo..."
    "${SCRIPT_DIR}/output/ipdemo" || echo "ipdemo test completed!"
else
    echo "ipdemo binary not found - run ./build.sh first"
fi